#! /usr/bin/perl -w

#####
#
# vD01.pl
# MDJ 2022/04/06
#
# Read the VerseData.csv file,
# split the data into variables,
# insert the data into the
# verseData Table in the
# KJVData datebase, and
# then display the data.
#
# Be sure to enter the proper
# mysql password before running 
# this script.
#
# To Run:
#   cdVD
#   vD01.pl
#
#####

# Pre-setup
use 5.30.0;
use warnings;

# Perl's Database Interface Module
use DBI;

# Data Source Name
my $dsn = "dbi:mysql:dbname=KJVData";

# mysql Username
my $user = "mdavidjohnson";

# mysql Password
#my $password = 'intentionallyObfuscated';

# mysql Attributes
my %attr = (RaiseError => 1, PrintError => 0);

# Open the Database Connection
my $dbh = DBI->connect($dsn, $user, $password, \%attr);

# Open the Input Data File
open(IN, '<VerseData.csv')
  or die "Can't open 'VerseData.csv' for reading: $!";
  
print "\nData Insertions starting\n\n";

while(<IN>)
{
	# Get a line from the file
	my $LineIN = $_;
	
	# Remove the line-ending "\n"
	chomp($LineIN);
	
	# Get the variables from the line
	(my $IDVal,
	 my $RunNumChaptersVal,
	 my $BookAbbrevVal,
	 my $ChapterNumVal,
	 my $NumVersesVal,
	 my $NumPrevVersesVal,
	 my $RunNumVersesVal)
	= split(/,/, $LineIN);
	
	# Insert the values into the Database Table
	$dbh->do("INSERT INTO verseData VALUES
	($IDVal,
	 $RunNumChaptersVal,
	 $BookAbbrevVal,
	 $ChapterNumVal,
	 $NumVersesVal,
	 $NumPrevVersesVal,
	 $RunNumVersesVal)");
	
	# Combine the variables
	my $sep = " -- ";
	my $LineOut = 	$IDVal.
	  $sep.$RunNumChaptersVal.
	  $sep.$BookAbbrevVal.
	  $sep.$ChapterNumVal.
	  $sep.$NumVersesVal.
	  $sep.$NumPrevVersesVal.
	  $sep.$RunNumVersesVal."\n";
	  
	# Print the combined variables
	print $LineOut;
}

print "\nData Insertions Complete\n\n";

# Close the Input Data File
close IN
  or die "Error closing 'VerseData.csv': $!";
  
# Close the Database Connection
$dbh->disconnect;
  
#####
#
# EOF
#
#####

